#include <stdlib.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <linux/cdrom.h>
#include <linux/major.h>

#define	EJECT	1
#define	CLOSE	2
#define SWITCH	3

#define IDE	1
#define	SCSI	2
#define ZIP	3
#define JAZ	4
#define FD	5

#define SLEEPTIME	2
#define VERSION "0c"

/*************************************************************************/

int checktype(int);

void opencd(int);
void closecd(int);

void openscsi(int);
void closescsi(int);

void doversion(char *);
void dohelp(char *);

/*************************************************************************/
	
int main(int argc, char **argv){
	int fd,  act=0, cdtype=0;
	char *device;
	if((device=getenv("CDROM"))==NULL)device="/dev/cdrom";
	
	if(argc>2)dohelp(argv[0]);	/* too many parms */
	if(argc==1)act=CLOSE;
	else switch(argv[1][0]){
		case 'c':
		case 'C':	act=CLOSE; break;	
		case 'o':
		case 'O':
		case 'e':
		case 'E':	act=EJECT; break;
		case 's':
		case 'S':	act=SWITCH; break;
		case 'v':
		case 'V':	doversion(argv[0]);
		default :	dohelp(argv[0]);
		}		

	if(argc==1)act=CLOSE;
	fd=open(device, O_RDONLY);

	cdtype=checktype(fd);		
	
	if(act==0){
		/* is open? is closed? is sucking my %$#@? */
		act=CLOSE;	/* fake it till we fix it *sigh*/
		};
	if(cdtype==IDE){
		ioctl(fd,CDROMEJECT_SW,0);              /* turn off autoeject */
		if(act==CLOSE)closecd(fd);
		if(act==EJECT)opencd(fd);
		if(act==SWITCH){opencd(fd); sleep(SLEEPTIME); closecd(fd);};
		}
	if(cdtype==SCSI){
	        if(act==CLOSE)closescsi(fd);
	        if(act==EJECT)openscsi(fd);
	        if(act==SWITCH){openscsi(fd); sleep(SLEEPTIME); closescsi(fd);};
	        }
	                                	
	close(fd);
	return 0;
	}

/*********************************************************************/

int checktype(int fd){
	struct stat devicestat;
	fstat(fd,&devicestat);
	if(devicestat.st_rdev==FLOPPY_MAJOR)return FD;
	if(devicestat.st_rdev==SCSI_CDROM_MAJOR)return SCSI;
	return IDE;
	}
	
void opencd(int fd){
	ioctl(fd,CDROMEJECT);
	return;
	}
void closecd(int fd){
	ioctl(fd,CDROMCLOSETRAY);
	ioctl(fd,CDROMSTOP);		/* stops the motor */
	return;
	}

void openscsi(int fd){
	return;
	}
void closescsi(int fd){
	return;
	}

void doversion(char *callname){
        printf("\n%s v %s by Erik Greenwald (br0ke@quakeworld.clipboard.com)\n\n",callname,VERSION);
        exit(1);
        }
void dohelp(char *callname){
        printf("\n%s v %s by Erik Greenwald (br0ke@quakeworld.clipboard.com)\n\n",callname,VERSION);
        printf("Usage:\n\t%s\t\t\tClose the cdrom\n",callname);
        printf("\t%s close\t\tClose the cdrom\n",callname);
	printf("\t%s open\t\tEject the cdrom\n",callname);
        printf("\t%s eject\t\tEject the cdrom\n",callname);
        printf("\t%s switch\t\topen the cdrom, wait a second, then close it\n",callname);
        printf("\t%s version\t\tdisplay version and exit\n",callname);
        printf("\t%s help\t\tdisplay this help and exit\n",callname);
        printf("\n\n");
        exit(1);
        }
